(* PRACTICA 7
   LABORATORIO DE PROGRAMACION II
*)

MODULE Drally;
IMPORT IO;
IMPORT MiStr;
IMPORT Window;
FROM Rally IMPORT Crear, Destruir, Introducir, EsVacio,Ganador,
                  CambiarVelocidad,Visualizar, Acelerar,RALLY,
                  Volcado, Revolcado;
VAR
  rally:RALLY;
  opcion:CHAR;
  bien:BOOLEAN;

PROCEDURE Menu();
BEGIN
    IO.WrLn;
    IO.WrStr("                 A.- Introducir nuevo coche.");IO.WrLn;
    IO.WrStr("                 B.- Ganador en este momento.");IO.WrLn;
    IO.WrStr("                 C.- Cambiar velocidad media.");IO.WrLn;
    IO.WrStr("                 D.- Visualizar campeonato.");IO.WrLn;
    IO.WrStr("                 E.- Acelerar algunas escuderias.");IO.WrLn;
    IO.WrStr("                 F.- Salir.");IO.WrLn;
    IO.WrStr("            Opciones con ficheros de texto: ");IO.WrLn;
    IO.WrStr("                 G.- Volcar a un fichero.");IO.WrLn;
    IO.WrStr("                 H.- Crear un rally desde un fichero.");IO.WrLn;
    IO.WrStr("                          Elija una opcion.      ");IO.WrLn;
END Menu;

PROCEDURE Error(bien:BOOLEAN);
BEGIN
  IF NOT bien THEN
    IO.WrStr(" Se produjo un error al realizar la accion ");IO.WrLn;
    IO.WrStr(" Puede que la estructura no este creada, o este vacia ");IO.WrLn;
    IO.WrStr(" o simplemente no haya memoria, o que el dato que busca ");IO.WrLn;
    IO.WrStr(" no este,esta introduciendo un coche que ya esta ");IO.WrLn;
    IO.WrStr(" o ya hay un coche en esa escuderia ");IO.WrLn;
    IO.WrLn;
    IO.WrStr(" Pulse cualquier tecla para continuar");
    REPEAT UNTIL IO.KeyPressed();
  END
END Error;


PROCEDURE OpcionA(VAR r:RALLY);
VAR
  e:ARRAY [1..20]OF CHAR;
  n,vm:INTEGER;
  bien:BOOLEAN;

BEGIN
    IO.WrStr(" Has elegido introducir un coche, dime los datos siguientes: ");
    IO.WrLn;
    IO.WrStr("1) Nombre de la escuderia: ");
    MiStr.RdCadena(e);           (* se permite usar RdStr *)
    IO.WrLn;
    IO.WrStr("2) Numero de participante(positivo): ");
    REPEAT n:=IO.RdInt() UNTIL n>0;
    IO.WrLn;
    IO.WrStr("3) Velocidad media: ");
    REPEAT vm:=IO.RdInt(); UNTIL vm>0;
    Introducir(r,e,n,vm,bien);
    Error(bien);
END OpcionA;

PROCEDURE OpcionB(VAR r:RALLY);
  VAR bien:BOOLEAN;
BEGIN
    Ganador(r,bien);
    Error(bien);
END OpcionB;

PROCEDURE OpcionC(VAR r:RALLY);
VAR
  e:MiStr.TCadena;
  n,vm:INTEGER;
  VAR bien:BOOLEAN;
BEGIN
    IO.WrStr(" Has elegido cambiar la velocidad media, dime los datos siguientes: ");
    IO.WrLn;
    IO.WrStr("1) Nombre de la escuderia: ");
    MiStr.RdCadena(e);
    IO.WrLn;
    IO.WrStr("2) Numero de participante(positivo): ");
    REPEAT n:=IO.RdInt() UNTIL n>0;
    IO.WrLn;
    IO.WrStr("3) Velocidad media: ");
    REPEAT vm:=IO.RdInt(); UNTIL vm>0;
    CambiarVelocidad(r,e,n,vm,bien);
    Error(bien);
END OpcionC;

PROCEDURE OpcionD(r:RALLY);
  VAR bien:BOOLEAN;
BEGIN
    Visualizar(r,bien);
    Error(bien);
END OpcionD;

PROCEDURE OpcionE(VAR r:RALLY);
VAR
  a:INTEGER;
  bien:BOOLEAN;
BEGIN
    IO.WrStr(" Has elegido acelerar algunas escuderias, teclea la aceleracion: ");
    REPEAT a:=IO.RdInt(); UNTIL a>0;
    Acelerar(r,a,bien);
    Error(bien);
END OpcionE;

PROCEDURE OpcionF(VAR o:CHAR);
VAR
  s:CHAR;
BEGIN
    IO.WrStr(" Realmente quiere salir?(S/N): ");
    REPEAT s:=CAP(IO.RdChar()) UNTIL (s='S') OR (s='N');
    IF s='S' THEN
       IO.WrLn;
       IO.WrStr(" Hasta luego Lucas.......! ");
    ELSE
       o:=s;
    END;
END OpcionF;

PROCEDURE OpcionG(rally:RALLY);
VAR
  bien:BOOLEAN;
  nomfich:MiStr.TCadena;
BEGIN
    IO.WrStr(" Nombre del fichero: ");
    IO.RdStr(nomfich);
    Volcado(rally,nomfich,bien);
    Error(bien);
END OpcionG;

PROCEDURE OpcionH(rally:RALLY);
VAR
  bien:BOOLEAN;
  nomfich:MiStr.TCadena;
BEGIN
    Destruir(rally,bien);
    rally:=Crear(bien);
    IF bien THEN
       IO.WrStr(" Nombre del fichero: ");
       IO.RdStr(nomfich);
       Revolcado(rally,nomfich,bien);
    END;
    Error(bien);
END OpcionH;


PROCEDURE Ejecutar(VAR r:RALLY;VAR o:CHAR);  (*!r DEBE PASARSE POR referencia!*)
BEGIN
    IO.WrLn;
    CASE o OF
         'A' : OpcionA(r)|
         'B' : OpcionB(r)|
         'C' : OpcionC(r)|
         'D' : OpcionD(r)|
         'E' : OpcionE(r)|
         'F' : OpcionF(o)|
         'G' : OpcionG(r)|
         'H' : OpcionH(r)
    END;
 END Ejecutar;

BEGIN
  rally:=Crear(bien);
  IF bien THEN
    REPEAT
      Window.Clear();
      Menu();
      REPEAT
        opcion:=CAP(IO.RdChar());
      UNTIL (opcion<='H') AND (opcion>='A');
      Window.Clear();
      Ejecutar(rally,opcion);
      IO.WrLn;
      IO.WrStr(" Operacion acabada, pulse 'C' para continuar. ");
      REPEAT UNTIL CAP(IO.RdChar())='C';
    UNTIL opcion='F';
    Destruir(rally,bien);                (*MUY IMPORTANTE !OJO!*)
    IF bien THEN
       IO.WrStr(" Estructura destruida. ")
    ELSE
       IO.WrStr(" Estructura no destruida. Hubo un error ")
    END;
  ELSE
    IO.WrStr(" No hay memoria para crear la estructura ");
    IO.WrLn;
    IO.WrStr(" Hasta luego Lucas.......")
  END;
END Drally.